%global xapian_core_support OFF
%global clang_support OFF

# open this flag when support more package (i.e. texlive) in the future
%bcond_with    tex

# open this flag when support texlive in the future
%bcond_with    testsuite

Summary:       A documentation system for C/C++
Name:          doxygen
Version:       1.9.5
Release:       3%{?dist}
License:       GPL+
Url:           https://github.com/doxygen
Source0:       https://doxygen.nl/files/%{name}-%{version}.src.tar.gz
Source1:       doxywizard.desktop
Source2:       doxywizard-icons.tar.xz

BuildRequires: %{_bindir}/python3
BuildRequires: gcc-c++ gcc cmake
BuildRequires: flex bison

%if %{without tex}
BuildRequires: zlib-devel
%else
BuildRequires: ghostscript gettext desktop-file-utils graphviz
BuildRequires: tex(dvips) tex(latex) tex(helvet.sty) tex(sectsty.sty)
BuildRequires: tex(tocloft.sty) tex(fontenc.sty) tex(fancyhdr.sty)
BuildRequires: tex(alltt.sty) tex(calc.sty) tex(float.sty) tex(verbatim.sty)
BuildRequires: tex(xcolor.sty) tex(fancyvrb.sty) tex(tabularx.sty)
BuildRequires: tex(multirow.sty) tex(hanging.sty) tex(ifpdf.sty)
BuildRequires: tex(adjustbox.sty) tex(amssymb.sty) tex(stackengine.sty)
BuildRequires: tex(ulem.sty) tex(ifthen.sty) tex(array.sty) tex(geometry.sty)
BuildRequires: tex(makeidx.sty) tex(natbib.sty) tex(graphicx.sty)
BuildRequires: tex(multicol.sty) tex(float.sty) tex(geometry.sty)
BuildRequires: tex(listings.sty) tex(color.sty) tex(xcolor.sty)
BuildRequires: tex(textcomp.sty) tex(wasysym.sty) tex(import.sty)
BuildRequires: tex(appendix.sty) tex(hyperref.sty) tex(pspicture.sty)
BuildRequires: tex(inputenc.sty) tex(mathptmx.sty) tex(courier.sty)
BuildRequires: tex(fixltx2e.sty) tex(ifxetex.sty) tex(caption.sty) tex(etoc.sty)
BuildRequires: tex(newunicodechar.sty) tex(varwidth.sty) tex(xtab.sty)
BuildRequires: tex(tabu.sty) /usr/bin/epstopdf texlive-epstopdf
%endif

%if "x%{?xapian_core_support}" == "xON"
BuildRequires: xapian-core-devel zlib-devel
%endif

%if "x%{?clang_support}" == "xON"
BuildRequires: llvm-devel clang-devel
%endif

%if %{with testsuite}
BuildRequires: texlive-bibtex
%endif

Requires:      perl-interpreter graphviz

%description
Doxygen is the de facto standard tool for generating documentation which
can help you in three ways:
1. It can generate an on-line documentation browser (in HTML) and/or an off-line
   reference manual (in LaTeX) from a set of documented source files.
2. It can configure doxygen to extract the code structure from undocumented source files.
3. It can create normal documentation


%if %{with tex}
%package       doxywizard
Summary:       A GUI for creating and editing configuration files
BuildRequires: qt5-qtbase-devel
Requires:      %{name} = %{version}-%{release}

%description   doxywizard
Doxywizard is a GUI for creating and editing configuration files that are used by doxygen.

%package       latex
Summary:       Support for producing latex/pdf output from doxygen
Requires:      %{name} = %{version}-%{release}
Requires:      tex(latex) tex(dvips) tex(helvet.sty) tex(sectsty.sty)
Requires:      tex(tocloft.sty) tex(fontenc.sty) tex(fancyhdr.sty)
Requires:      tex(alltt.sty) tex(calc.sty) tex(float.sty) tex(verbatim.sty)
Requires:      tex(xcolor.sty) tex(fancyvrb.sty) tex(tabularx.sty)
Requires:      tex(multirow.sty) tex(hanging.sty) tex(ifpdf.sty)
Requires:      tex(adjustbox.sty) tex(amssymb.sty) tex(stackengine.sty)
Requires:      tex(ulem.sty) tex(ifthen.sty) tex(array.sty) tex(geometry.sty)
Requires:      tex(makeidx.sty) tex(natbib.sty) tex(graphicx.sty)
Requires:      tex(multicol.sty) tex(float.sty) tex(geometry.sty)
Requires:      tex(listings.sty) tex(color.sty) tex(xcolor.sty)
Requires:      tex(textcomp.sty) tex(wasysym.sty) tex(import.sty)
Requires:      tex(appendix.sty) tex(hyperref.sty) tex(pspicture.sty)
Requires:      tex(inputenc.sty) tex(mathptmx.sty) tex(courier.sty)
Requires:      tex(fixltx2e.sty) tex(ifxetex.sty) tex(caption.sty)
Requires:      tex(etoc.sty) tex(newunicodechar.sty) tex(varwidth.sty)
Requires:      tex(tabu.sty) tex(xtab.sty) texlive-bibtex texlive-makeindex texlive-epstopdf

%description   latex
A documentation system for C/C++
%endif

%prep
%autosetup -p1 -a2

%build
%cmake \
      -DPYTHON_EXECUTABLE=%{_bindir}/python3 \
      -Duse_libclang=%{clang_support} \
      -Dbuild_doc=OFF \
      -Dbuild_xmlparser=ON \
      -DMAN_INSTALL_DIR=%{_mandir}/man1 \
      -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \
      -DBUILD_SHARED_LIBS=OFF \
%if %{without tex}
      -Dbuild_wizard=OFF \
      -Dbuild_search=OFF \
%else
      -Dbuild_wizard=ON \
      -Dbuild_search=%{xapian_core_support} \
%endif

%cmake_build

%install
%cmake_install

%if %{with tex}
install -m644 -p -D doxywizard-6.png %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/doxywizard.png
install -m644 -p -D doxywizard-5.png %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/doxywizard.png
install -m644 -p -D doxywizard-4.png %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/doxywizard.png
install -m644 -p -D doxywizard-3.png %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/doxywizard.png
%endif

install -Dt %{buildroot}/%{_mandir}/man1/ doc/*.1

%if %{without tex}
rm -f %{buildroot}/%{_mandir}/man1/doxywizard.1*
%endif

%if "x%{?xapian_core_support}" == "xOFF"
rm -f %{buildroot}/%{_mandir}/man1/doxyindexer.1* %{buildroot}/%{_mandir}/man1/doxysearch.1*
%endif

rm -rf %{buildroot}/%{_docdir}/packages

%if %{with tex}
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{SOURCE1}
%endif

%check
%if %{with testsuite}
%ctest
%endif

%files
%license LICENSE
%doc LANGUAGE.HOWTO README.md
%{_bindir}/doxygen
%{_mandir}/man1/doxygen.1*

%if "x%{?xapian_core_support}" == "xON"
%if %{with tex}
%{_bindir}/doxyindexer
%{_bindir}/doxysearch*
%endif
%{_mandir}/man1/doxyindexer.1*
%{_mandir}/man1/doxysearch.1*
%endif

%if %{with tex}
%files doxywizard
%{_bindir}/doxywizard
%{_datadir}/applications/doxywizard.desktop
%{_datadir}/icons/hicolor/*/apps/doxywizard.png
%{_mandir}/man1/doxywizard*
%endif

%if %{with tex}
# blank package
%files latex
%endif

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.5-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.5-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Oct 18 2022 Shuo Wang <abushwang@tencent.com> - 1.9.5-1
- initial build

